package com.example.smartl

import android.os.Build
import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.activity.viewModels
import androidx.annotation.RequiresApi
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.Surface
import androidx.compose.ui.Modifier
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import com.example.smartl.api.RepositoryImpl
import com.example.smartl.api.RetrofitInstance
import com.example.smartl.screens.navigation.Navigation
import com.example.smartl.ui.theme.SmartLTheme



class MainActivity : ComponentActivity() {
    private val viewModel_Smart by viewModels<ViewModelMain>(factoryProducer = {
        object : ViewModelProvider.Factory {
            override fun <W : ViewModel> create(modelClass: Class<W>): W {
                return ViewModelMain(RepositoryImpl(RetrofitInstance.api))
                        as W
            }
        }
    })
    @RequiresApi(Build.VERSION_CODES.O)
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            SmartLTheme {
                Surface(
                    modifier = Modifier.fillMaxSize(),
                    color = MaterialTheme.colorScheme.background
                ) {
                    Navigation(viewModel_Smart)

                }
            }
        }
    }
}