package com.example.smartl.screens.navigation

import android.os.Build
import androidx.annotation.RequiresApi
import androidx.compose.runtime.Composable
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.example.smartl.ViewModelMain
import com.example.smartl.screens.ConfirmationEmail_3
import com.example.smartl.screens.LogApp_2
import com.example.smartl.screens.NewPassword_4
import com.example.smartl.screens.Screensaver_1


@RequiresApi(Build.VERSION_CODES.O)
@Composable
fun Navigation(viewModel: ViewModelMain) {
    val navController = rememberNavController()
    NavHost(navController = navController,
        startDestination = "Screensaver_1")
    {
        composable("Screensaver_1"){
            Screensaver_1(navController)
        }
        composable("LogApp_2"){
            LogApp_2(navController, viewModel)
        }
        composable("ConfirmationEmail_3"){
            ConfirmationEmail_3(navController, viewModel)
        }
        composable("NewPassword_4"){
            NewPassword_4(navController)
        }
    }
}